/*
 * This software is the confidential and proprietary information of
 * Smardec. You shall not disclose or distribute such Confidential Information.
 * This software shall not be integrated, copied (partially or fully),
 * or reverse engineered into any other software, program, or code that is
 * not intended for Smardec. You shall use it only in accordance with the terms
 * of the license agreement you entered into with Smardec.
 *
 * Copyright (C) 2004-2006 Smardec. All rights reserved.
 *
 * http://www.smardec.com
 *
 */

package com.smardec.demo.j2native.demos;

import com.smardec.asc.hyperlink.HyperlinkUtil;
import com.smardec.demo.j2native.DemoableAdapter;
import com.smardec.demo.j2native.Util;

import javax.swing.*;
import javax.swing.border.TitledBorder;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import java.awt.*;
import java.util.Vector;

public class AboutDemo extends DemoableAdapter {
    public final static String CONSTRAINT_ABOUT = "About";
    public final static String CAPTION_ABOUT = "About";
    public final static String INTRO_ABOUT = "<html><head>" + css + "</head><body>" +
            "<p color=black text-align=justify>&nbsp;&nbsp;&nbsp;&nbsp;The  Smardec company welcomes you. We are glad that youve got interested by our J2Native product and downloaded the demo version. We hope and believe that you will find the possibilities of the library valuable and sufficient for you and the demo will convince you of the right choice youve made." +
            "<br>&nbsp;&nbsp;&nbsp;&nbsp;If you still dont know what J2Native is and how useful it can be for you, you should get acquainted with the brief information about the product, given below. You can find the full description of the library in the appropriate section of our website. If you have any questions, you can address them to the support team. Well be glad to answer them." +
            "<br>&nbsp;&nbsp;&nbsp;&nbsp;J2Native is a Java library which serves as a means of connection between Java and native libraries. It means that each time you need to go to the system or to one of your own libraries you may use J2Native for that. Such a necessity may arise when in order to increase your programme performance you place a part of the code into native libraries, or when Java platform doesnt have some necessary possibilities, or when you have legacy software and you are planning to use it in a new Java application, or whatever, there can be lots of variants. And only one thing unites them  you have to take functions from native libraries, impart some parameters to them and get the necessary result. At the same time you want to preserve control over the application and not to exceed the bounds of pure Java. Besides you want to save your time and not to spend it on studying JNI, but the most important is that you want to create the necessary code quickly and easily. J2Native is a special tool which was created exactly for these purposes. Making use of J2Native for achieving of your goals, you will get everything you want and even more. With the help of J2Native you can widely use the potential of the platform being the basis of your system. Such things as icons in system tray and/or windows of various shape will become available to you due to the use of the library. All Java platform limitations will disappear for you as a software creator and nothing will constrain your imagination any longer. Thanks to J2Native you will get a unique opportunity to create outstanding applications. And you will get all this, working with Java only." +
            "<br><br><b>Technical advantages:</b></p>" +
            "<table cellspacing=0 cellpadding=0 border=0>" +
            "<tr><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>-</td><td valign=top color=black>&nbsp;</td><td valign=top color=black><b>Full support of native calling conventions.</b></td></tr>" +
            "<tr><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>J2Native supports STDCALL and CDECL calling conventions, as well as all compound data such as structures and unions. Callbacks are also fully supported and can be used in a cross-platform cooperation as well as any other argument. Full support of native calling conventions.</td></tr>" +
            "<tr><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>-</td><td valign=top color=black>&nbsp;</td><td valign=top color=black><b>Automatic resource management.</b></td></tr>" +
            "<tr><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>Any object created by J2Native releases automatically when you do not need it any longer. Thus, all J2Native objects can be viewed as usual Java objects, which will be gathered into Java garbage collector.</td></tr>" +
            "<tr><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>-</td><td valign=top color=black>&nbsp;</td><td valign=top color=black><b>Efficient performance.</b></td></tr>" +
            "<tr><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>&nbsp;</td><td valign=top color=black>Taking into account the fact that efficiency is our priority, we can say that a considerable amount of time and attention was devoted to J2Native performance optimization. As a result the library is fast, reliable and save.</td></tr>" +
            "</table>" +
            "<p color=black>&nbsp;&nbsp;&nbsp;&nbsp;This is only a short list of J2Native advantages over the similar software, the full list is available at our web-site. And despite the fact that J2Native possibilities are impressive, we keep on improving them. At the same time we consider our customers desires and expectations when  working out every new version." +
            "<br>&nbsp;&nbsp;&nbsp;&nbsp;And now we invite you to have a look at our demonstration copy.</p>" +
            "<br><br><b>Links:</b>" +
            "<table cellspacing=0 cellpadding=0 border=0>" +
            "<tr><td valign=top color=black>&nbsp;&nbsp;-&nbsp;&nbsp;<b>Smardec web site:</b></td><td>&nbsp;<a href=http://www.smardec.com>http://www.smardec.com</a></td></tr>" +
            "<tr><td valign=top color=black>&nbsp;&nbsp;-&nbsp;&nbsp;<b>J2Native web page:</b></td><td>&nbsp;<a href=http://www.smardec.com/products/j2native.html>http://www.smardec.com/products/j2native.html</a></td></tr>" +
            "<tr><td valign=top color=black>&nbsp;&nbsp;-&nbsp;&nbsp;<b>Obfuscation by Allatori:</b></td><td>&nbsp;<a href=http://www.allatori.com>http://www.allatori.com</a></td></tr>" +
            "</table>" +
            "</body></html>";

    private JPanel jPanelOptions = null;
    private JPanel jPanelDesc = null;

    public String getID() {
        return CONSTRAINT_ABOUT;
    }

    public String getCaption() {
        return CAPTION_ABOUT;
    }

    public Vector getContentDescriptions() {
        return null;
    }

    public int getState() {
        return STATE_NONE;
    }

    public JPanel getDemoPanel() {
        JPanel jPanelAbout = new JPanel(new GridBagLayout());
        TitledBorder titledBorder = BorderFactory.createTitledBorder(CAPTION_ABOUT);
        titledBorder.setTitleColor(Color.black);
        jPanelAbout.setBorder(titledBorder);
        JEditorPane jEditorPane = new JEditorPane("text/html", INTRO_ABOUT);
        jEditorPane.setEditable(false);
        jEditorPane.setCaretPosition(0);
        jEditorPane.setBackground(jPanelAbout.getBackground());
        jEditorPane.addHyperlinkListener(new HyperlinkListener() {
            public void hyperlinkUpdate(HyperlinkEvent e) {
                if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
                    if (e.getURL() != null)
                        HyperlinkUtil.openInternetBrowser(e.getURL().toString());
                }
            }
        });

        Util.constrain(jPanelAbout, new JScrollPane(jEditorPane),
                0, 0, 1, 1, GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST, 1, 1,
                0, 5, 0, 5);

        return jPanelAbout;
    }

    public JPanel getOptionPanel() {
        if (jPanelOptions != null)
            return jPanelOptions;
        return null;
    }

    public JPanel getDescriptionPanel() {
        if (jPanelDesc != null)
            return jPanelDesc;
        return null;
    }
}
