/*
 * This software is the confidential and proprietary information of
 * Smardec. You shall not disclose or distribute such Confidential Information.
 * This software shall not be integrated, copied (partially or fully),
 * or reverse engineered into any other software, program, or code that is
 * not intended for Smardec. You shall use it only in accordance with the terms
 * of the license agreement you entered into with Smardec.
 *
 * Copyright (C) 2004-2006 Smardec. All rights reserved.
 *
 * http://www.smardec.com
 *
 */

package com.smardec.demo.j2native.demos;

import com.smardec.demo.j2native.Demo;
import com.smardec.demo.j2native.DemoableAdapter;
import com.smardec.demo.j2native.Util;
import com.smardec.demo.j2native.tools.NativeLibraryHelper;

import javax.swing.*;
import javax.swing.border.TitledBorder;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import java.awt.*;
import java.util.Vector;


public class LinuxDemo extends DemoableAdapter {
    public final static String CONSTRAINT_LINUX = "Linux";
    public final static String CAPTION_LINUX = "Linux/Solaris";
    public final static String URL_VIEWER = "viewer.html";
    public final static String INTRO_LINUX = "<html><head>" + css + "</head><body>" +
            "<p align=left color=black>" +
            "<b>User Viewer.</b><br>" +
            "A programmer creating software for Linux often should have information about a user who launches the application. Standard possibilities of Java to give such information are rather limited and frequently insufficient. That is why we created User Viewer program to demonstrate the possibilities of J2Native library. The program consists of two parts - user info and group info." +
            "<br>User info reflects information about system users. To do that the program chooses data from <i>/etc/passwd</i> and <i>/etc/shadow</i> files using system API. (NOTE: program works in Read-Only mode. No changes will be made under any circumstances.)  The set of given data includes information about users IDs and their names, their home folder, groups they belong to and even information about users passwords and their system accounts." +
            "<br>Group info chooses information about all groups existing in the system. This information contains data about groups ID, its name and members." +
            "<br>We want to point out once again that the program does not have a change code and serve only to demonstrate the possibilities of J2Native library." +
            "<p align=right color=black><a href=" + URL_VIEWER + ">View Code Sample</a></p>" +
            "</p>" +
            "</body></html>";
    private JPanel jPanelOptions = null;
    private JPanel jPanelDesc = null;

    public String getID() {
        return CONSTRAINT_LINUX;
    }

    public String getCaption() {
        return CAPTION_LINUX;
    }

    public Vector getContentDescriptions() {
        return null;
    }

    public int getState() {
        return STATE_NONE;
    }

    public JPanel getDemoPanel() {
        JPanel jPanelContents = new JPanel(new GridBagLayout());
        TitledBorder titledBorder = BorderFactory.createTitledBorder(CAPTION_LINUX);
        titledBorder.setTitleColor(Color.black);
        jPanelContents.setBorder(titledBorder);
        JEditorPane jEditorPane = new JEditorPane("text/html", INTRO_LINUX);
        jEditorPane.setEditable(false);
        jEditorPane.setCaretPosition(0);
        jEditorPane.setBackground(jPanelContents.getBackground());
        jEditorPane.addHyperlinkListener(new HyperlinkListener() {
            public void hyperlinkUpdate(HyperlinkEvent e) {
                if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
                    showSourceDialog(e.getDescription());
                }
            }
        });

        Util.constrain(jPanelContents, new JScrollPane(jEditorPane),
                0, 0, 1, 1, GridBagConstraints.BOTH, GridBagConstraints.NORTHWEST, 1, 1,
                0, 5, 0, 5);
        return jPanelContents;
    }

    public JPanel getOptionPanel() {
        if (jPanelOptions != null)
            return jPanelOptions;
        return null;
    }

    public JPanel getDescriptionPanel() {
        if (jPanelDesc != null)
            return jPanelDesc;
        return null;
    }

    private void showSourceDialog(String url) {
        final Demo instance = Demo.getInstance();
        if (URL_VIEWER.equals(url)) {
            instance.setActiveDemo(LinUserManagerDemo.CONSTRAINT_LIN_USER_MANAGER);
            instance.showSrcPanel(50);
        }
    }

    public void init(Component parentFrame) {
        NativeLibraryHelper.getInstance();
    }

    public void deinit() {
        NativeLibraryHelper.getInstance().reset();
    }
}

