/*
 * This software is the confidential and proprietary information of
 * Smardec. You shall not disclose or distribute such Confidential Information.
 * This software shall not be integrated, copied (partially or fully),
 * or reverse engineered into any other software, program, or code that is
 * not intended for Smardec. You shall use it only in accordance with the terms
 * of the license agreement you entered into with Smardec.
 *
 * Copyright (C) 2004-2006 Smardec. All rights reserved.
 *
 * http://www.smardec.com
 *
 */

package com.smardec.demo.j2native.tools;

public class SysInfoUtil {
    public static final int WIN32 = 1;
    public static final int WIN9x = 2;
    public static final int UNIX = 4;
    public static final int MAC = 8;
    public static final int OS2 = 16;
    public static final int SUNOS = 32;

    public static int getSystem() {
        String osName = System.getProperty("os.name").toLowerCase();
        if (osName.startsWith("windows 9") || osName.startsWith("windows me")) {
            return WIN9x;
        } else if (osName.startsWith("windows")) {
            return WIN32;
        } else if (osName.startsWith("mac")) {
            return MAC;
        } else if (osName.startsWith("os/2") || osName.startsWith("os2")) {
            return OS2;
        } else if (osName.startsWith("sunos")) {
            return SUNOS;
        } else {
            return UNIX;
        }
    }

    public static boolean isWin() {
        int system = getSystem();
        return (system == WIN32 || system == WIN9x);
    }

    public static boolean isSunOS() {
        int system = getSystem();
        return (system == SUNOS);
    }

    public static boolean isUnix() {
        return (getSystem() == UNIX);
    }
}
